package com.nova.flutter_ads;

import android.app.Activity;
import android.graphics.Color;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewTreeObserver;
import android.widget.FrameLayout;

import com.ark.adkit.polymers.polymer.ADTool;


import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.platform.PlatformView;

public class FlutterAdsBannerView implements PlatformView {

    private final FrameLayout rootView;

    @Override
    public void onFlutterViewAttached(View flutterView) {
        Log.d("banner","onFlutterViewAttached"+ getView().getHeight()+"");
    }
    public FlutterAdsBannerView(final Activity activity, BinaryMessenger messenger, int i) {
        rootView = new FrameLayout(activity);
        FrameLayout.LayoutParams layoutParams =
                new FrameLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        rootView.setLayoutParams(layoutParams);
        rootView.setBackgroundColor(Color.WHITE);
        ADTool.getADTool().getManager().getNativeWrapper().loadBannerView(activity, rootView);
        final MethodChannel methodChannel = new MethodChannel(messenger, "plugins.nova.ads/bannerview_"+i);
        rootView.getViewTreeObserver().addOnGlobalLayoutListener(new ViewTreeObserver.OnGlobalLayoutListener() {
            @Override
            public void onGlobalLayout() {
                int height = rootView.getHeight();
                final int tempHeigh = height;
                if (height > 50){  //过滤错误尺寸
                    rootView.getViewTreeObserver().removeOnGlobalLayoutListener(this);
                    activity.runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            final int heightDp = DisplayUtils.px2dip(activity, tempHeigh);
                            Log.d("banner","addOnGlobalLayoutListener");
                            methodChannel.invokeMethod("height",heightDp);
                        }
                    });
                }

            }
        });
    }

    @Override
    public View getView() {
        return rootView;
    }

    @Override
    public void dispose() {

    }
}
