package com.nova.flutter_ads;

import android.app.Activity;
import android.content.Context;
import android.os.Handler;
import android.os.Looper;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.LinearLayout;

import com.ark.adkit.basics.models.OnSplashImpl;
import com.ark.adkit.polymers.polymer.ADTool;

import io.flutter.plugin.common.BasicMessageChannel;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.StringCodec;
import io.flutter.plugin.platform.PlatformView;

public class FlutterAdsSplashView implements PlatformView {

    private final FrameLayout rootView;

    private final static String splashEventName = "plugins.nova.ads.event/splashview";

    private Handler handler;

    private static BasicMessageChannel<String> runTimeSender;

    FlutterAdsSplashView(Activity activity, BinaryMessenger messenger, int id) {
        rootView = new FrameLayout(activity);
        FrameLayout.LayoutParams layoutParams =
                new FrameLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
        rootView.setLayoutParams(layoutParams);
        LinearLayout flAd = new LinearLayout(activity);
        rootView.addView(flAd);
        this.handler = new Handler(Looper.getMainLooper());
        runTimeSender = new BasicMessageChannel<String>(messenger, splashEventName, StringCodec.INSTANCE);
        ADTool.getADTool().getManager()
                .getSplashWrapper().
                needPermissions(FlutterAdsPlugin.needPermission)
                .loadSplash(activity, flAd, rootView, new OnSplashImpl() {
                    @Override
                    public void onAdTimeTick(long tick) {
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                runTimeSender.send("123");
                            }
                        });
                    }

                    @Override
                    public void onAdShouldLaunch() {
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                runTimeSender.send("finish");
                            }
                        });
                    }

                    @Override
                    public void onAdDisable() {
                        super.onAdDisable();
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                runTimeSender.send("finish");
                            }
                        });
                    }
                });


    }

    @Override
    public View getView() {
        return rootView;
    }

    @Override
    public void dispose() {

    }
}
