//
// Created by John Shu on 2020/3/10 12:08.
// Copyright (c) 2020 shupeng. All rights reserved.
//

#import "FlutterAdsNativeViewFactory.h"
#import "FlutterAdsNativeView.h"


@interface FlutterAdsNativeViewFactory ()

@end

@implementation FlutterAdsNativeViewFactory {
    NSObject <FlutterBinaryMessenger> *_messenger;
}

- (instancetype)initWithMessenger:(NSObject <FlutterBinaryMessenger> *)messager {
    self = [super init];
    if (self) {
        _messenger = messager;
    }
    return self;
}

//设置参数的编码方式
- (NSObject <FlutterMessageCodec> *)createArgsCodec {
    return [FlutterStandardMessageCodec sharedInstance];
}

- (nonnull NSObject <FlutterPlatformView> *)createWithFrame:(CGRect)frame viewIdentifier:(int64_t)viewId arguments:(id _Nullable)args {
    FlutterAdsNativeView *nativeView = [[FlutterAdsNativeView alloc] initWithWithFrame:frame
                                                                        viewIdentifier:viewId
                                                                             arguments:args
                                                                       binaryMessenger:_messenger];

    return nativeView;
}
@end