// create by shupeng

#import "FlutterAdsSplashView.h"
#import <NOVAdKit/NOVAdManager.h>

@interface FlutterAdsSplashView ()
@end

@implementation FlutterAdsSplashView {
    int64_t _viewId;
    UIView *_splashView;
    FlutterBasicMessageChannel *_channel;
}

- (instancetype)initWithWithFrame:(CGRect)frame viewIdentifier:(int64_t)viewId arguments:(id)args binaryMessenger:(NSObject <FlutterBinaryMessenger> *)messenger {
    if ([super init]) {
        _splashView = [[UIView alloc] initWithFrame:CGRectZero];
        _splashView.backgroundColor = [UIColor clearColor];
        NSString *channelName = @"plugins.nova.ads.event/splashview";
        _channel = [FlutterBasicMessageChannel messageChannelWithName:channelName binaryMessenger:messenger
                                                                codec:[FlutterStringCodec sharedInstance]];
        _viewId = viewId;

        [self loadGDTSplash];
    }
    return self;
}

- (void)loadGDTSplash {
    [[NOVAdManager shared] showSplashWithCustomView:nil callback:^(NOVAdState state, NSError *_Nullable error) {
        if (state == NOVAdCanNotShowAd
                || state == NOVAdWillClose
                || state == NOVAdDidFailed) {
            [self->_channel sendMessage:@"finish"];
        }
    }];
}

- (nonnull UIView *)view {
    return _splashView;
}


@end
