import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

import 'flutter_ads.dart';

typedef AdsIsFinish = void Function();

typedef AdsTick = void Function(num);

class AdsNativeView extends StatefulWidget {
  final AdsIsFinish asdIsFinish;
  final AdsTick adsTick;

  const AdsNativeView({Key key, this.asdIsFinish, this.adsTick})
      : super(key: key);

  @override
  _AdsNativeViewState createState() => _AdsNativeViewState();
}

class _AdsNativeViewState extends State<AdsNativeView> {
  var tempHeight = FlutterAds.maxNativeHeight;
  var boolOffstate = true;

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    if (defaultTargetPlatform == TargetPlatform.android) {
      return Offstage(
        offstage: boolOffstate,
        child: SizedBox(
          height: tempHeight,
          child: AndroidView(
            viewType: 'plugins.nova.ads/nativeview',
            onPlatformViewCreated: (id) async {
              MethodChannel _channel =
                  new MethodChannel('plugins.nova.ads/nativeview_$id');
              _channel.setMethodCallHandler((call) {
                if (call.method == 'height') {
                  int height = call.arguments;
                  tempHeight = height.toDouble();
                  boolOffstate = false;
                  print("nativeHeight$height");
                  setState(() {});
                }
              });
            },
            creationParamsCodec: const StandardMessageCodec(),
          ),
        )
      );
    } else {
      return UiKitView(viewType: 'plugins.nova.ads/nativeview');
    }
  }
}
